######Uppsala R workshop - Day 1######
###code block 1

dataG <- data.frame(y = rnorm(5,mean=0,sd=sqrt(1)))
dataG$y

yscale <- seq(-3,3,0.1) #possible values of y for the plot
Prob<-dnorm(yscale,mean=0,sd=sqrt(1)) #pdf
plot(Prob~yscale,type="l")
Prob.y <- dnorm(dataG$y, mean=0, sd=sqrt(1))
points(Prob.y~dataG$y)

L <- prod(Prob.y)
L

Lalt <- prod(dnorm(dataG$y,mean=0,sd=sqrt(0.5)))
Lalt


plot(dnorm(yscale,0,sqrt(0.5))~yscale,type="l")
lines(Prob~yscale,col="red")
points(Prob.y~dataG$y,col="red")
points(dnorm(dataG$y,0,sqrt(0.5))~dataG$y)


###code block 2

x=seq(-2,2,0.05)
y=seq(0,6,0.05)
z=matrix(numeric(length(x)*length(y)),c(length(x),length(y)))

for (i in 1:length(x)) {

	for (j in 1:length(y)){

		z[i,j]=prod(dnorm(dataG$y,mean=x[i],sd=sqrt(y[j])))
	}
}

z<-z/max(z)
contour(x,y,z,nlevels=10,xlab="mean",ylab="variance")


###code block 3

loglik <- function(pars,y) {
	sum(dnorm(y,pars[1],sqrt(pars[2]),log=TRUE))
}

ML <- optim(c(mean=0,v=1),fn=loglik,y=dataG$y,
	control=list(fnscale=-1,reltol=1e-16))
ML$par

REML <- glm(y~1,data=dataG)
summary(REML)

#REML estimator is better (the bias is smaller by 
#factor of n/n-1)
ML$par["v"]*(5/4)


###code block 4

library(MCMCpack)

logprior <- function(pars,priorR,priorB) {
	dnorm(pars[1],mean=priorB$mu,sd=sqrt(priorB$V),log=T)+
	log(dinvgamma(pars[2],shape=priorR$nu/2,
	scale=(priorR$nu*priorR$V)/2))
}

prior <- list(R=list(V=1,nu=0.002),B=list(mu=0,V=1e+08))

loglikprior <- function(pars,y,priorR,priorB) {
	loglik(pars,y)+logprior(pars,priorR,priorB)
}

Bayes <- optim(c(mean=0,v=1),fn=loglikprior,y=dataG$y,
	priorR=prior$R,priorB=prior$B,
	control=list(fnscale=-1,reltol=1e-16))


x=seq(-2,2,0.05)
y=seq(0,6,0.05)
z1=matrix(numeric(length(x)*length(y)),c(length(x),length(y)))

for (i in 1:length(x)) {

	for (j in 1:length(y)){

		z1[i,j]=exp(loglikprior(c(x[i],y[j]),
		dataG$y,prior$R,prior$B))
	}
}

#z2<-z1/max(z1) sometimes does not work as NaNs are produced
contour(x,y,z,nlevels=10,xlab="mean",ylab="variance")
contour(x,y,z1,nlevels=10,xlab="mean",ylab="variance",
		add=T,col="red")


###code block 5

contour(x,y,z1,nlevels=10,xlab="mean",ylab="variance",
		col="red")
library(MCMCglmm)
m1 <- MCMCglmm(y~1,data=dataG,prior=prior,thin=1,nitt=30000,
verbose=F)
points(cbind(m1$Sol,m1$VCV),pch=".")


###code block 6

prop.table(table(m1$Sol > -2 & m1$Sol<2 & m1$VCV<6))
hist(m1$VCV[which(m1$VCV<6)],breaks=30)
abline(v=Bayes$par["v"],col="red")


###code block 6a

yield<-read.table("splityield.txt",head=T,sep="\t")
summary(yield)

m1a.yield <- MCMCglmm(yield~(irrigation+density+fertilizer)^2-
		density:fertilizer, data=yield, 
		verbose=F, prior=list(R=list(V=1,nu=0.002),
		G=list(G1=list(V=1,nu=0.002))))

plot(m1.yield$Sol)
plot(m1.yield$VCV)

HPDinterval(m1.yield$Sol)
HPDinterval(m1.yield$VCV)

posterior.mode(m1.yield$Sol)
posterior.mode(m1.yield$VCV)


###code block 7

prior.fl <- list(R=list(V=1e-16,nu=-2))
m1.fl <- MCMCglmm(y~1, data=dataG, thin=1,
		prior=prior.fl,verbose=F)


###code block 8

library(lme4)
library(MCMCglmm)
data(BTdata)
lm1.bt1 <- lmer(tarsus~sex+(1|fosternest)+(1|dam),data=BTdata)
summary(lm1.bt1)
lm1.bt2 <- lmer(tarsus~sex+(1|dam),data=BTdata)
anova(lm1.bt1,lm1.bt2)
lm1.bt3 <- lmer(tarsus~sex,data=BTdata)

library(nlme)
lm1.bt3 <- lme(tarsus~sex,random=~1|dam,data=BTdata)
lm1.bt3a <- lm(tarsus~sex,data=BTdata)
anova(lm1.bt3,lm1.bt3a)
detach(package:lme4)
detach(package:nlme)


###code block 9

library(lme4)
lm2.bt <- lmer(tarsus~sex+(1|fosternest)+(sex-1|dam),data=BTdata)
summary(lm2.bt)
matrix(VarCorr(lm2.bt)$dam,3,3)


###code block 10

tv<-summary(lm1.bt1)@coefs[,3][2]
#access to t-value for sexMale
df<-dim(BTdata)[1]-nlevels(BTdata$dam)-
	nlevels(BTdata$fosternest)
2*(1-pt(tv,df))
#two-tailed test, beware of the sign of tv

Fv<-anova(lm1.bt1)[,4][1]
1-pf(Fv,2,df)


###code block 11

prior <- list(R=list(V=1,nu=0.002),
		G=list(G1=list(V=1,nu=0.002),
		G2=list(V=1,nu=0.002)))
m2.bt1 <- MCMCglmm(tarsus~sex, random=~fosternest+dam,
		prior=prior,verbose=F, data=BTdata)
summary(m2.bt1)

m2.bt2 <- MCMCglmm(tarsus~sex, random=~dam, prior=prior,
		verbose=F, data=BTdata)
m2.bt1$DIC; m2.bt2$DIC #it seems we should keep fosternest
plot(m2.bt1$VCV)

prior <- list(R=list(V=1,nu=0.002),
		G=list(G1=list(V=1,nu=0.002),
		G2=list(V=diag(3),nu=1.002)))
m2.bt3 <- MCMCglmm(tarsus~sex, random=~fosternest+us(sex):dam,
		prior=prior,verbose=F, data=BTdata)
summary(m2.bt3)
coda::HPDinterval(m2.bt3$VCV)
r <- m2.bt3$VCV[,3]/sqrt(m2.bt3$VCV[,2]*m2.bt3$VCV[,6])
coda::HPDinterval(r)
m2.bt1$DIC; m2.bt3$DIC

#correlations for different variance components are negative
cor(m2.bt1$VCV)

#we could test dam effect in usual way but instead we'll see
#how big proportion of variance it explains

prop.v <- m2.bt1$VCV[,2]/rowSums(m2.bt1$VCV)
coda::HPDinterval(prop.v)
#if you remember to detach lmer after use, you can skip coda::

###code block 12

prior <- list(R=list(V=1,nu=0.002),
		G=list(G1=list(V=1,nu=0.002),
		G2=list(V=1,nu=0.002)))
m3.bad <- MCMCglmm(tarsus~sex, random=~fosternest+dam, 
		prior=prior,verbose=F, data=BTdata, nitt=2000, 
		burnin=500, thin=2)
plot(m3.bad$VCV)
autocorr(m3.bad$VCV)

m3.good <- MCMCglmm(tarsus~sex, random=~fosternest+dam, 
		prior=prior,verbose=F, data=BTdata, 
		nitt=50000, burnin=3000, thin=50)
plot(m3.good$VCV)
autocorr(m3.good$VCV)
#try below if you don't want to have huge 
#complex matrix outputs
diag(autocorr(m3.good$VCV)[2,,])


###code block 12a

effectiveSize(m3.good$VCV)
effectiveSize(m3.bad$VCV)



###code block 13

x <- runif(1000, 0, 1) #uniform random variable
z <- rnorm(1000, 0, sqrt(1.5)) #normal random variable
l <- 0.5 + 1*x + 2*z #desired linear predictor
yp <- rpois(1000, exp(l)) #added Poisson residuals to response
glmdata <- data.frame(y = yp, x = x, z = z)
pois1<-glm(y~x+z,data=glmdata,family="poisson")
summary(pois1) #coeficients are on the right scale
#because we exp the linear pred

pois2<-glm(y~x,data=glmdata,family="poisson")
summary(pois2)
pois2$deviance/pois2$df.residual

pois21<-glm(y~x,data=glmdata,family="quasipoisson")
summary(pois21)

pois3<-MCMCglmm(y~x,data=glmdata,family="poisson",verbose=F)
summary(pois3)

###code block 14

library(MASS)
data(Traffic)
Traffic$year<-as.factor(Traffic$year)

m4.bad <- glm(y~limit+year+day,family="poisson",data=Traffic)
summary(m4.bad)
m4.bad$deviance/m4.bad$df.residual
# >3 times greater variation than expected


###code block 15

prior <- list(R=list(V=1,nu=0.002))
m4.good <- MCMCglmm(y~limit+year+day,family="poisson",data=Traffic,
		prior=prior,verbose=F,pl=T)
lat92 <- m4.good$Liab[,92]
eta92 <- m4.good$Sol[,"(Intercept)"]+m4.good$Sol[,"day"]*92
resid92 <- lat92-eta92
mean(resid92)

###1-ppois(exp(mean(eta92)),exp(mean(lat92)))###
###ADDITIONAL CODE###
days<-1:92
days2<-as.character(days)
overd<-data.frame(days=1:92)
a<-vector()
for(i in 1:92) {
	lat<-m4.good$Liab[,i]
	
	eta<-m4.good$Sol[,"(Intercept)"]+m4.good$Sol[,"day"]*i
	resid<-lat-eta
	a<-c(a,mean(resid))
		}

overd<-data.frame(overd,a)

a<-vector()
for (i in 1:92) {
	eta<-m4.good$Sol[,"(Intercept)"]+m4.good$Sol[,"day"]*i
	a<-c(a,mean(eta))
}

overd<-data.frame(overd,a)

overd2<-data.frame(days=1:92)
for (j in 1:92) {
a<-vector()
for (i in 1:92) {
	
	etar<-m4.good$Sol[,"(Intercept)"]+overd[j,2]+m4.good$Sol[,"day"]*i
	a<-c(a,mean(etar))
	
}
overd2<-data.frame(overd2,a)
}
		

plot(overd[,3]~overd[,1],lwd=2,type="l",ylim=c(1,5))

for(i in 1:92) {
	lines(overd2[,i+1]~overd2[,1],col="red",lty=3)
}
lines(overd2[,92]~overd2[,1],col="black",lty=2,lwd=3)





###code block 16

X <- model.matrix(y~limit+year+day,data=Traffic)
X[c(1,2,3,91,92,183,184),]
m5.fix <- MCMCglmm(y~limit+year+day,data=Traffic,verbose=F,family="poisson")
# using default prior
#prediction for 1961 and 1962 with no speed limit
y61.m5.fix <- m5.fix$Sol[,"(Intercept)"]
y62.m5.fix <- m5.fix$Sol[,"(Intercept)"]+m5.fix$Sol[,"year1962"]
posterior.mode(y61.m5.fix)
posterior.mode(y62.m5.fix)


###code block 17

Z <- model.matrix(~year-1,data=Traffic)
Z[c(1,2,3,91,92,183,184),]
X2 <- model.matrix(y~limit+day,data=Traffic)
X2[c(1,2,3,91,92,183,184),]
W<-cbind(X2,Z)
W[c(1,2,3,91,92,183,184),]

prior <- list(R=list(V=1,nu=0.002),
			G=list(G1=list(V=1e+08,fix=1)))
m5.ran<-MCMCglmm(y~limit+day,random=~year,family="poisson",
		data=Traffic,verbose=F,prior=prior,pr=T) 
		#pr save the posterior of random effects
y61.m5.ran <- m5.ran$Sol[,"(Intercept)"]+
			m5.ran$Sol[,"year.1961"]
y62.m5.ran <- m5.ran$Sol[,"(Intercept)"]+
			m5.ran$Sol[,"year.1962"]

#comparing posteriors for year effects from fixed and random effects

y.fix <- mcmc(cbind(y1961=y61.m5.fix,y1962=y62.m5.fix))
y.ran <- mcmc(cbind(y1961=y61.m5.ran,y1962=y62.m5.ran))
plot(mcmc.list(y.fix,y.ran)) #virtually the same!

#unfortunately as we have just two levels of year
#treating this as random confounds year effects with intercept

plot(c(m5.ran$Sol[,"year.1962"]+
	m5.ran$Sol[,"year.1961"])/2,m5.ran$Sol[,"(Intercept)"])


###code block 18

Traffic$day<-as.factor(Traffic$day)
prior <- list(R=list(V=1,nu=0.002),
			G=list(G1=list(V=1,nu=0.002)))
m6 <- MCMCglmm(y~limit+year+as.numeric(day),random=~day,
	family="poisson",data=Traffic,prior=prior,verbose=F)
summary(m6)
plot(m6$VCV)
autocorr(m6$VCV)
#we'll run the model for longer to treat
#autocorrelation in residuals

m6 <- MCMCglmm(y~limit+year+as.numeric(day),random=~day,
	family="poisson",data=Traffic,prior=prior,verbose=F,
	nitt=100000,burnin=20000,thin=50)
plot(m6$VCV)
#traces look better butperhaps improper 
#or expanded priors would be better


###code block 19

ones <- rbinom(20, size=5, prob=c(0.2,0.8))
zeros <- 5-ones
bdata <- rbind(ones,zeros)
bdata<-rbind(bdata,unit=letters[1:20])
bdata<-as.data.frame(t(bdata))
prior <- list(R=list(V=1,nu=0.002))
m7.bin <- MCMCglmm(cbind(ones,zeros)~1,
		data=bdata,family="multinomial2",
		prior=prior,verbose=F,nitt=100000,
		burnin=20000,thin=50)
summary(m7.bin)
install.packages("boot");library(boot)
inv.logit(summary(m7.bin)$solutions[1]) #intercept is 0.5
plot(m7.bin$VCV)

data(PlodiaR)
m8.bin <- MCMCglmm(cbind(Pupated,Infected)~1, 
		family="multinomial2",
		data=PlodiaR, verbose=F)
plot(m8.bin$VCV)

#are Family effects really so variable?
mode.mu <- posterior.mode(m8.bin$Sol)
mode.V <- posterior.mode(m8.bin$VCV)
ondatascale <- inv.logit(rnorm(10000, mean=mode.mu, 
				sd=sqrt(mode.V)))
hist(ondatascale) #yes, it is!

###code block 20

data(PlodiaRB)
prior1 <- list(R=list(V=1,fix=1),G=list(G1=list(V=1,nu=0.002)))
prior2 <- list(R=list(V=2,fix=1),G=list(G1=list(V=1,nu=0.002)))

m9.bin1 <- MCMCglmm(Pupated~1,random=~FSfamily,
		family="categorical",
		data=PlodiaRB,prior=prior1,verbose=F)
m9.bin2 <- MCMCglmm(Pupated~1,random=~FSfamily,
		family="categorical",
		data=PlodiaRB,prior=prior2,verbose=F)

plot(mcmc.list(m9.bin1$Sol,m9.bin2$Sol))
plot(mcmc.list(m9.bin1$VCV,m9.bin2$VCV))#both posteriors differ!


###code block 21

IC1 <- m9.bin1$VCV[,1]/(rowSums(m9.bin1$VCV)+pi^2/3)
IC2 <- m9.bin2$VCV[,1]/(rowSums(m9.bin2$VCV)+pi^2/3)
plot(mcmc.list(IC1,IC2))


###code block 22

c <- 16*sqrt(3)/(15*pi)
Int1 <- m9.bin1$Sol/sqrt(1+c^2*m9.bin1$VCV[,2])
Int2 <- m9.bin2$Sol/sqrt(1+c^2*m9.bin2$VCV[,2])
plot(mcmc.list(Int1,Int2)) #the same


###code block 23

hist(inv.logit(rnorm(1000,0,sqrt(1e+08))))
#alternatively
#hist(plogis(rnorm(1000,0,sqrt(1e+08))))


###code bloc 24

exper <- gl(2,25)
y <- rbinom(50,1,c(0.5, 0.001)[exper])
bdata2 <- data.frame(exp=exper,y=y)
table(bdata2)

m10.glm <- glm(y~exp,data=bdata2,family="binomial")
summary(m10.glm)

prior.def<-list(R=list(V=1,fix=1))
m10.mc <- MCMCglmm(y~exp,data=bdata2,family="categorical",
				prior=prior.def,verbose=F)
summary(m10.mc)
plot(m10.mc$Sol)

prior.better <- list(R=list(V=1,fix=1),
			B=list(mu=c(0,0),V=diag(2)*(1+pi^2/3)))
m10.mc2 <- MCMCglmm(y~exp,data=bdata2,family="categorical",
		prior=prior.better, verbose=F)
plot(m10.mc2$Sol)
#looks much better but may need running for longer

#checking if the results conform to simpler test - exact binomial
m10.test <- binom.test(table(bdata2)[2,2],25)
m10.test

predict(m10.mc2,interval="confidence")[26,]


###code block 25


prior.a <- list(R=list(V=1,nu=0.002),
		G=list(G1=list(V=1,nu=0.002),
		G2=list(V=diag(3),nu=0.002)))
m11.bta <- MCMCglmm(tarsus~sex, random=~fosternest+idh(sex):dam,
		prior=prior.a,verbose=F, data=BTdata)
plot(m11.bta$VCV)
#UNK has low dam variance which may be problematic


###code block 26

Vdam.a <- diag(colMeans(m11.bta$VCV)[2:4])
colnames(Vdam.a) <- colnames(m11.bta$VCV)[2:4]
Vdam.a

plotsubspace(Vdam.a,axes.lab=T)
#elipsoid depicting this covariance structure


###code block 27

prior.b <- list(R=list(V=1,nu=0.002),
		G=list(G1=list(V=1,nu=0.002),
		G2=list(V=diag(3)*0.02,nu=4.002)))
m11.btb <- MCMCglmm(tarsus~sex, random=~fosternest+us(sex):dam, 
		prior=prior.b,
		verbose=F, data=BTdata)
plot(m11.btb$VCV)

Vdam.b <- matrix(colMeans(m11.btb$VCV)[2:10],3,3)
colnames(Vdam.b) <- colnames(m11.btb$VCV)[2:4]
Vdam.b

plotsubspace(Vdam.b,axes.lab=T)
#elipsoid depicting this covariance structure
plot(posterior.cor(m11.btb$VCV[,2:10])[,c(3,4,8)])
#all r roughly equal to 1

"simpler model";m2.bt1$DIC
"us() variance structure";m11.btb$DIC
"idh() variance structure";m11.bta$DIC


###code block 28

nu.star <- prior.b$G$G2$nu - dim(prior.b$G$G2$V)[1]*1
V.star <- prior.b$G$G2$V[1,1]*(prior.b$G$G2$nu/nu.star)
xv <- seq(1e-16,1,length=100)
library(MCMCpack)
dv<-dinvgamma(xv,shape=nu.star/2,scale=(nu.star*V.star)/2)
detach(package:MCMCpack)
plot(dv~xv,type="l")
